﻿using Syncfusion.Windows.Controls.Grid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ForegroundColor
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            grid.ModelLoaded += grid_ModelLoaded;
        }

        private void grid_ModelLoaded(object sender, EventArgs e)
        {
            grid.Model.Grid.PrepareRenderCell += Grid_PrepareRenderCell;
        }

        void Grid_PrepareRenderCell(object sender, GridPrepareRenderCellEventArgs e)
        {
            if (e.Style.RowIndex > 0)
            {
                var columnindex = this.grid.Model.ResolvePositionToVisibleColumnIndex(e.Style.ColumnIndex);
                if (columnindex >= 0 && this.grid.VisibleColumns[columnindex].MappingName == "EmployeeID")
                {
                    var cell = this.grid.Model[e.Cell.RowIndex, e.Style.ColumnIndex].CellValue;
                    int result = Convert.ToInt32(cell);
                    if (result == 1000)
                    {
                        //set Selected row Foreground color
                        e.Style.Foreground = Brushes.Blue;
                    }
                }
                else
                {
                    e.Style.Foreground = Brushes.Green;
                }
            }
        }
    }
}
